#include <stdio.h>

#include "vosid.h"

/** CMDLINE OPTIONS */
show_params()
{
 printf("VoSiD %s		by Sampo Savolainen 1996\n",VERSION);
 printf("usage:   vosid [options]\n");
 printf("options: -s1		Stop after 10 seconds of silence [default] (p)\n");
 printf("         -s2		Stop after voice is heard (p)\n");
 printf("         -s3		Stop when it's silent [unusable]\n");
 printf("         -s4		Don't stop. [not recommended] (p)\n");
 printf("         -s5		Stop after voice has stopped (p)\n");
 printf("         -p file	Use other %dhz raw sample (max 10 seconds)\n",
        SAMPLING_RATE);
 printf("         -n level	Noise level\n");
 printf("         -q		Quiet (no sound output)\n");
 printf("         -v		Show output when silence/voice is detected\n");
 printf("         -V		Show pattern advances & restarts\n");
 printf("         -f file	Use file as a pattern\n");
 printf("         -h 		Show this message\n");
 printf("         -T		Show the time at shutdown\n");
 printf(" (p) means that the style is usable with patterns.\n");
 exit(1);
}

/**************************************************
*** CMDLINE OPTION PARSER  *************************
*** Gulps. This might suck.. It's the first one  ***
*** I've ever made (on a larger scale, of course ***
*** I've done small ones).                       ***
***************************************************/

void parser(int argc, char **argv)
{
 int x;
 
 sstyle  = 1;
 quiet_b = onoise_b = verbose_b = othersample = pattern_b = 0;
 
 if (argc!=1) 
  for (x=1; x<argc; x++)
   if (argv[x][0]!='-') show_params(); else	/* -* */
    if (argv[x][1]=='s')			 /* -s? */
     {
      if (argv[x][2]=='1') sstyle=1; else	  /* -s1 */
      if (argv[x][2]=='2') sstyle=2; else	  /* -s2 */
      if (argv[x][2]=='3') sstyle=3; else	  /* -s3 */
      if (argv[x][2]=='4') sstyle=4; else	  /* -s4 */
      if (argv[x][2]=='5') sstyle=5; else          /* -s5 */
      { printf("Unknown style"); show_params(); }
     } else
    if (argv[x][1]=='f') {			/* -f filename */
    			  pattern_b=1;
    			  patternfn=argv[x+1];
    			  x++;
    			 } else
    if (argv[x][1]=='p') {                      /* -p filename */
                          othersample=1;
                          osamplename=x+1;
                          x++;
                         } else
    if (argv[x][1]=='n') {
                          onoise_b=1;
                          x++;
                          noiselevel=atol(argv[x]);
                         } else        /* -n level */
    if (argv[x][1]=='q') quiet_b=1; else	 /* -q  */
    if (argv[x][1]=='v') verbose_b=1; else	 /* -v  */
    if (argv[x][1]=='V') verbosep_b=1; else	 /* -V  */
    if (argv[x][1]=='T') time_b=1; else		 /* -T  */
     { 						/* -h or -whatever */
      if (argv[x][1]!=104) printf("Unknown parameter\n");
      show_params();
      
     }
 
 if (sstyle == 3 && pattern_b == 1)
  {
   printf("Style 3 can't be used with patterns\n");
   show_params();
  }
                    
}