/****************************************************************************
*** VOICE/SILENCE DETECTOR - VoSiD		by Sampo Savolainen 1996 *****
*******************************************************************************
*** This is a very simple program, which checks if the mic is receiving any ***
*** sound beyond the background noise.                                      ***
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <math.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#include "vosid.h"


/********************************
*************** MAIN FUNCTION ****
*********************************/
void main(int argc, char **argv)
{
 int orig_vol,
     new_vol,
     noise,
     sample,
     silence_c,
     silence_b,
     pattern_c,
     voice_b,
     clrs_b,
     quit_b,
     svoice_b,
     x,y,z;

 parser(argc,argv);

/********* CREATING/LOADING PING "WAVE" */
 if (othersample==1) {
                      printf("Loading %s...\n",argv[osamplename]);
                      sample=open(argv[osamplename],O_RDONLY);
                      if (sample==-1) {
                                       perror(argv[osamplename]);
                                       exit(-1);
                                      }
                      x=0;
                      while ( read(sample,l,1) == 1 )
                      {
                       sampleb[x]=l[0];
                       x++;
                      }
                      samplesize=x-1;
                      close(sample);
                     } else

 for (x=0; x<PINGSIZE; x++) wave[x]=sin(x+1)*(128/(x/PINGSIZE+0.001))+128;

 x = silence_c = quit_b = 0;

/********* OPENING THE DEVICES */
 
 dsp	 = open (DSP_DEVICE,O_RDWR);
 if (dsp==-1) { perror(DSP_DEVICE);
                exit (-1); }
 
 mixer	 = open (MIXER_DEVICE,O_RDWR);
 if (mixer==-1) { perror(MIXER_DEVICE);
                  exit (-1); }

/********* CHECKING FOR PATTERN FILE */
 
 x = pattern_check();
 
 if (x==-2 || x==-4) { exit(-1); }

 x = 0;
 
/********* OPENING SEQUENCE */
 printf("VoSiD %s		by Sampo Savolainen 1996\n",VERSION);

/********* SAVING&DEFINING MIC VOLUME */
 ioctl (mixer,MIXER_READ(7),&orig_vol);
 
 new_vol = (100 & 0xff) | ((100 & 0xff) << 8);
 ioctl (mixer,MIXER_WRITE(7),&new_vol);


/********* SOUND PARAMETERS */
 x=SAMPLING_BITS;
  ioctl (dsp, SOUND_PCM_WRITE_BITS,     &x);

 x=MONO;
  ioctl (dsp, SOUND_PCM_WRITE_CHANNELS, &x);

 x=SAMPLING_RATE;
  ioctl (dsp, SOUND_PCM_WRITE_RATE,     &x);


/********* NOISE CHECK */
 if (onoise_b==0)
 {
  printf ("Measuring noise level, please be quiet.\n");
  noise   = get_noise();
 } else
  noise = noiselevel;
 printf ("Noise level %d\n",noise);
 
 printf("Starting silence/voice detector:\n");

 silence_c=SENSITIVITY+1;

 x = silence_b = pattern_c = quit_b = svoice_b = 0;

 if (sstyle==3) { voice_b = 1; if (verbose_b==1) printf("Noise\n");
                               if (quiet_b==0) ping(); }

/*****************************************************************
********* MAIN LOOP*************************************************
**** In this while you can change the way this program works	 ****
**** i.e. a sound-trigger would be "while (voice_b==0)"		 ****
****   (This example is obsolete nowadays, but it still gives)	 ****
****    an example what can be done)				 ****
********** *  *   *    *     *     *     *    *   *  * **************
**** voice_b      a fake-boolean, 1 when voice is heard, 0	 ****
****              when not.					 ****
**** silence_b    a fake-boolean, 1 when silent, 0 when not.	 ****
**** quiet_b      a fake-boolean, 1 stop loop, 0 continue.	 ****
**** silence_c    silence counter, every sampling which is	 ****
****              within the "noise" range, is counted here,	 ****
****              when voice is heard, this counter is 0'ed.	 ****
**** quit_b       a fake-boolean, when it's zero the loop will   ****
****              go on, otherwise the loop is broken.           ****
********************************************************************/

 while (quit_b==0)
 {
   read(dsp,l,1);
  
   if ( abs(l[0]-128) < noise+1 ) silence_c++; else silence_c=0;
 
   if (pattern_b==0) /* Start of non-pattern mode */
   {
   
   if (silence_b == 0) if (silence_c>SENSITIVITY) {
                                                    voice_b=0;
                                                    silence_b=1;
                                                    if (verbose_b==1)
                                                     printf("Silence\n");
                                                   }
   if (voice_b   == 0) if (silence_c<SENSITIVITY) {
       						   voice_b=1;
                                                   silence_b=silence_c=0;
                                                   if (verbose_b==1)
                                                    printf("Noise\n");
                                                   if (quiet_b==0) ping();
                                                  }
   if (sstyle==1) if (silence_c > SAMPLING_RATE*10) 	quit_b=1;
   if (sstyle==2) if (voice_b   == 1)			quit_b=1;
   if (sstyle==3) if (silence_b == 1)			quit_b=1;
   if (sstyle==5) { if (voice_b	== 1) svoice_b=1; else
                    if (svoice_b== 1) quit_b=1; }
  } else
  
   /* Start of the shining-new (in 4th Oct 1996) pattern detector */
   { 
    if (pattern[pattern_c]=='1') x=1; else x=0; 
    
    if (silence_c>P_SILENCE_TIME) {
      if (x==0) {
       pattern_c++;
       silence_c=1; 
       if (verbosep_b==1) printf("+pattern-advance, 0\n");
     } else if (pattern_c!=0) 
      {
       pattern_c=0;
       silence_c=1;
       if (verbosep_b==1) printf("-pattern-restart, 0\n");
     }
    } else
    if (silence_c==0) {
      if (x==1) {
       pattern_c++;
       if (verbosep_b==1) printf("+pattern-advance, 1\n");
      } else {
       pattern_c=0;
       if (verbosep_b==1) printf("-pattern-restart, 1\n");
     }
   /* NOW A LOOP UNTIL THERE IS SILENCE or the sound will trigger
      pattern-restarts all over the place... :)                   */
 
      read(dsp,l,1);
      y=z=0;
      while (y<P_SENSITIVITY)
       {
        if (abs(l[0])-128 < noise+1)
         y++; else y=0;
         read(dsp,l,1);
         
         if (z!=-1) z++;
         if (z>16000) {
          pattern_c=0;
          z=-1;
          if (verbosep_b==1) printf("-pattern-restart, 1\n");
         
         }
         silence_c=10;
       }
     }
   
   if (sstyle==1 && silence_c > SAMPLING_RATE*10) quit_b=1;
   if (sstyle==2 && pattern_c ==strlen(pattern) ) quit_b=1;
   if (sstyle==5 && pattern_c ==strlen(pattern) ) quit_b=1;    
   if (verbose_b == 1 && pattern_c==strlen(pattern)) printf("pattern-match\n");
   if (pattern_c==strlen(pattern)) {
    pattern_c=0;
    if (quiet_b==0) ping();
   }
   } /* End of Pattern mode */
                    
 }

/********* RESTORING VALUES */
 if (time_b==1) {
  timme=time(NULL);
  printf("At %s",asctime(localtime(&timme)));
 }

 printf ("De-initializing...");
 ioctl  (mixer, MIXER_WRITE(7), &orig_vol); 
 printf (".");
 close  (dsp);
 printf (".");
 close  (mixer);
 printf ("...Done\n");
}